<template>

    <div class="row">
        <div class="col-md-12">
            <br>
            <h2>Search Restaurants</h2>
            <div class="form-group ">

                    <gmap-autocomplete class="form-control"
                                       @place_changed="setPlace">
                    </gmap-autocomplete>
              <center><br>
                    <button class="btn btn-info" @click="addMarker">Add</button>
              </center>


            </div>


        </div>
        <div class="col-md-12">
            <br>
            <gmap-map
                :center="center"
                :zoom="12"
                style="width:100%;  height: 400px;"
            >
                <gmap-marker
                    :key="index"
                    v-for="(m, index) in markers"
                    :position="m.position"
                    @click="center=m.position"
                ></gmap-marker>
            </gmap-map>
        </div>

    </div>

</template>

<script>
    export default {
        props: ['dataLng','dataLat'],
        name: "GoogleMap",
        data() {
            return {
                // default to Montreal to keep it simple
                // change this to whatever makes sense
                center: {lat:40, lng: -17},
                markers:[],
                places: [],
                currentPlace: null
            };
        },

        mounted() {
            this.geolocate();
            this.defaultMarker();

        },

        methods: {
            // receives a place object via the autocomplete component
            setPlace(place) {
                this.currentPlace = place;
            },
            defaultMarker(){
                const marker = {
                    lat:parseFloat(this.dataLat),
                    lng: parseFloat(this.dataLng)
                };
                this.markers.push({position: marker});
                this.places.push(this.currentPlace);
                this.center = marker;
                this.currentPlace = null;
            },
            addMarker() {
                if (this.currentPlace) {
                    const marker = {
                        lat: this.currentPlace.geometry.location.lat(),
                        lng: this.currentPlace.geometry.location.lng()
                    };
                    console.log(marker);
                    this.markers.push({position: marker});
                    this.places.push(this.currentPlace);
                    this.center = marker;
                    this.currentPlace = null;
                }

            },
            geolocate: function () {

                navigator.geolocation.getCurrentPosition(position => {
                    this.center = {
                        lat: position.coords.latitude,
                        lng: position.coords.longitude
                    };
                });
            }
        }
    };
</script>
